print("TODO list : \n -Ajouter le menu clic droit du grapheur (Optionnel)")


print("Loading libs and starting program")

import sys

sys.path.insert(0, 'AI/')
sys.path.insert(1, 'API/')

import tkinter as Tk
import tkinter.messagebox
import tkinter.ttk as Ttk
import threading
from random import randint, sample

from os import getcwd, listdir, startfile, remove as fileDelete, rename as fileRename, mkdir
from os.path import exists as fileExist
from platform import system
from time import strftime as timeNow, sleep, time
from math import ceil, floor
from keyboard import press_and_release as pressKey
import numpy as np

from API import API

from AI.ComposedClassifier import ComposedClassifier as AI
from AI.ComposedClassifier import ComposedClassifier
from AI.EEGDecodingModel import EEGDecodingModel
from AI.EEGDecodingModelFBCSP import EEGDecodingModelFBCSP



# Windows size
sizeX, sizeY = 640, 480
autoSize = True


## Constants and other vars that can be changed are located at the end of var declaration and before the __init()__ function






rootDir = getcwd() + "/"
onWindows = True
notSupportedOutsideWin = ("Open in file explorer", "Nothing else")
trashLocation = "THE endless pit"


class InterfaceIA:



    tk = None
    threadIA = None
    files = []

    screenX, screenY = 0, 0;


    # Dummy variables
    tmp = None

    # Frames of the main window
    mainFrame = None
    fileFrame = None
    graphFrame = None
    buttonFrame = None
    manageFrame = None

    #file explorer
    fileSelector = None

    #buttons
    historyButton = None
    trainButton = None
    livepredictButton = None
    bciButton = None
    createDatasetButton = None

    #manager
    datasetText = None
    deleteButton = None

    #graph
    PLOT_LINE, PLOT_BAR, PLOT_DOT = "plot_line", "plot_bar", "plot_dot"
    graph = None

    graphXOffset, graphYOffset = 20, 20
    graphX, graphY = 0, 0
    graphAxisXMin, graphAxisXMax, graphAxisYMin, graphAxisYMax = 0, 0, 0, 0

    graphHoverlay = None


    #OpenBCI settings
    openBCIWin = None
    comPortsListbox = None
    connectButton = None

    #OpenBCI Dataset creation
    openBCIDataset = None
    datasetCanvas = None
    datasetPatern = None


    
    DATASET_BLACK = -1
    DATASET_BLACK_DURATION = 1.5
    DATASET_CROSS_1 = -2
    DATASET_CROSS_1_DURATION = 2
    DATASET_CROSS_2 = -3
    DATASET_CROSS_2_DURATION = 2.75

    
    
    datasetData = None
    datasetTempo = 0
    datasetReadWindows = []
    

    entryName = None
    entry1stName = None
    entryEmail = None
    
    
    #API
    APIInstance = None
    APIConnected = None
    APIStarted = False
    threadAcquire = None


    #AI
    nbClasses = 3
    AIInstance = None
    AIModels = []
    AIClassifiers = []
    nbEpochTrain = 125





    #### ========== Constants and free to edit vars ========== ####


    # Dataset intro
    datasetIntroText = [["Hi", 1500], ["We'll ask you to follow some basic instructions", 3000], ["Stay focused on the white cross in the center of the screen", 3000], ["An arrow will appear and then disappear from this cross", 3000], ["Rise your corresponding arm when the arrow disappear", 4000], ["Then, release your arm when the cross disappear", 3000], ["Stay relaxed and focused all the way", 3000], ["Time to begin !", 2000]]

    # Dataset actions
    DATASET_LEFT = 3
    DATASET_RIGHT = 2
    DATASET_NONE = 1

    # Dataset name
    DATASET_NAME = {DATASET_NONE:"Nothing", DATASET_RIGHT:"Right hand", DATASET_LEFT:"Left hand", DATASET_BLACK:"Black screen", DATASET_CROSS_1:"Wait", DATASET_CROSS_2:"Acquire"}
    
    # Dataset content
    datasetActions = {DATASET_LEFT: [30, 1.25], DATASET_RIGHT: [30, 1.25], DATASET_NONE: [30, 1.25]} # Scheme : {action1: [nb_actions1, time_in_s action1], action2: [nb_actions2, time_in_s_action2], ...}

    #Dataset settings
    entryDatasetNumber = None
    selectvarDatasetNumber = None
    
    # Allowed keyboard keys for AI feedback
    availableKeys = [None]
    availableKeys.extend([str(chr(i)) for i in range(ord('a'), ord('z')+1)])
    availableKeys.extend([str(chr(i)) for i in range(ord('0'), ord('9')+1)])
    availableKeys.extend(["left_arrow", "right_arrow", "up_arrow", "down_arrow"])

    
    #### ========== End of Constants and free to edit vars ========== ####


    #Return keys
    returnDict = {DATASET_LEFT: "z", DATASET_RIGHT:"s", DATASET_NONE:None}
    optionmenuKeyboard = {}
    selectvarKeyboard = {}

    


    def __init__(self):
        global onWindows, sizeX, sizeY, autoSize
        # Create Tk window
        self.tk = Tk.Tk()
        self.tk.title("AI interface")

        self.screenX = self.tk.winfo_screenwidth()
        self.screenY = self.tk.winfo_screenheight()

        print("Monitor size : {}x{}".format(self.screenX, self.screenY))

        if(autoSize):
            sizeX = int(self.screenX/1.5)
            sizeY = int(self.screenY/1.5)

        print("Window size : {}x{} {}".format(sizeX, sizeY, "(auto)" if(autoSize) else "" ))

        self.tk.geometry('{}x{}'.format(sizeX+6, sizeY+6))
        self.tk.resizable(0,0)


        if(system() != "Windows"):
            onWindows = False
            tmp = ""
            for i in notSupportedOutsideWin:
                tmp += "\n  - " + i
            Tk.messagebox.showwarning("Warning !", "Some functions will not work on this OS (" + system() + ").\nOnly Windows is fully supported\nList of known non supported features :"+tmp)

        # Init frames
        self.mainFrame = Tk.Frame(self.tk, bg='yellow', width=sizeX, height=sizeY)
        self.mainFrame.pack(padx=3, pady=3)

        tmpF = Tk.Frame(self.mainFrame)
        tmpC = Tk.Canvas(tmpF, width=sizeX/2, height=sizeY*4/5)
        fileSelectorScrollbar=Tk.Scrollbar(tmpF,orient="vertical", command=tmpC.yview)
        self.fileFrame= Tk.Frame(tmpC)

        self.fileFrame.bind(
            "<Configure>",
            lambda e: tmpC.configure(
                scrollregion=tmpC.bbox("all")
            )
        )

        tmpC.create_window((0, 0), window=self.fileFrame, anchor="nw")
        tmpC.configure(yscrollcommand=fileSelectorScrollbar.set)

        tmpF.place(relx=0, rely=0)
        tmpC.pack(side="left", fill="both", expand=True)
        fileSelectorScrollbar.place(relx=1, rely=0, relheight=1, anchor=Tk.NE)
        tmpF.bind('<Enter>', lambda e: tmpC.bind_all("<MouseWheel>", lambda ee: tmpC.yview_scroll(int(-1*(ee.delta/120)), "units")))
        tmpF.bind('<Leave>', lambda e: tmpC.unbind_all("<MouseWheel>"))
        

        self.buttonFrame = Tk.Frame(self.mainFrame, padx=10, pady=10, width=sizeX/2, height=sizeY/5)
        self.buttonFrame.place(x=0, y=sizeY*4/5, width=sizeX/2, height=sizeY/5)
        
        self.manageFrame = Tk.Frame(self.mainFrame, padx=5, pady=5, width=sizeX/2, height=sizeY/2)
        self.manageFrame.place(x=sizeX/2, y=0, width=sizeX/2, height=sizeY/2)

        self.graphFrame = Tk.Frame(self.mainFrame, padx=0, pady=0, width=sizeX/2, height=sizeY/2)
        self.graphFrame.place(x=sizeX/2, y=sizeY/2, width=sizeX/2, height=sizeY/2)


        # Separators
        #Ttk.Separator(self.mainFrame, orient="vertical").place(relx=0.5, rely=0, relwidth=0.001, relheight=1)
        Ttk.Separator(self.mainFrame, orient="horizontal").place(relx=0, rely=0.8, relwidth=0.5, relheight=0.001)
        Ttk.Separator(self.mainFrame, orient="horizontal").place(relx=0.5, rely=0.5, relwidth=0.5, relheight=0.001)

        

        # fileSelector widgets
        Tk.Label(self.fileFrame, text="Choose a file to load").pack()
        self.fileSelector = Tk.Listbox(self.fileFrame, selectmode=Tk.EXTENDED)
        self.fileSelector.bind('<<ListboxSelect>>',self._onFileSelectorClick)
        self.updateFileExplorer()
        self.fileSelector.pack()
        Tk.Button(self.fileFrame, text="Refresh list", command=self.updateFileExplorer).pack()

##        for i in range(30):
##            Tk.Label(self.fileFrame, text="Just some garbage to fill some empty places "+str(i)).pack()




        # buttonFrame widgets
        self.historyButton = Tk.Button(self.buttonFrame, text="History", command=None)
        self.historyButton.grid(row=0, column=0, padx=5, pady=2)

        self.livepredictButton = Tk.Button(self.buttonFrame, text="Start AI on live", command=self.startAIOnLive, state=Tk.DISABLED)
        self.livepredictButton.grid(row=1, column=0, padx=5, pady=2)
        
        self.trainButton = Tk.Button(self.buttonFrame, text="Train AI with these files", command=self.startAITrain)
        self.trainButton.grid(row=1, column=1, padx=5, pady=2)
        self.updateTrainButton(False)

        self.bciButton = Tk.Button(self.buttonFrame, text="OpenBCI menu", command=self.openBCIMenu)
        self.bciButton.grid(row=0, column=1)

        self.createDatasetButton = Tk.Button(self.buttonFrame, text="Create dataset", command=self.createNewDataset)
        self.createDatasetButton.grid(row=0, column=2)
        self.updateDatasetButton(False);


        # manageFrame widgets
        self.datasetText = Tk.Message(self.manageFrame, text="Nothing to display", fg="black", bg="white", bd=0, width=sizeX/2)
        self.datasetText.place(relx=0.5, rely=0, anchor=Tk.N)

        self.deleteButton = Tk.Button(self.manageFrame, text="Delete file(s)", command=self.deleteFiles, justify=Tk.CENTER)
        self.deleteButton.place(relx=0, rely=1, anchor=Tk.SW)
        self.updateDeleteButton(False)


        # graphFrame canvas
        self.graph = Tk.Canvas(self.graphFrame, width=sizeX/2, height=sizeY/2, bd=0, bg="white", cursor="cross")
        self.graph.place(relx=0, rely=0, anchor=Tk.NW)
        self.graphX, self.graphY = sizeX/2-self.graphXOffset*2, sizeY/2-self.graphYOffset*2
        self.graph.bind("<Button-3>", self.openGraphSettings)
        self.graph.bind("<Motion>", self.graphHovered)
        self.graph.bind("<Leave>", self.graphNotHovered)

        self.graphHoverlay = Tk.Label(self.graphFrame, text="Test")
        self.graphHoverlay.place(relx=-100, rely=-100)

        self.plot([[-5, -2, 3, 5], [0, 1, 2, 3], [1, 2, 4, 5]], [[0, 3, -2, 5], [0, 1, 2, 3], [2, 4, 5, 9]], plotMode=(InterfaceIA.PLOT_LINE, InterfaceIA.PLOT_DOT, InterfaceIA.PLOT_BAR), color=("red", "green", "blue"), stroke=(1, 5, 2))

        #Init API
        print("Linking to API....", end="")
        self.APIInstance = API(dataInterval=125)
        self.APIInstance.setDataReceivedFunction(self.fromAPIToAI)
        print(" Done")


        #Init AI
        print("Linking to AI....")
        self.AIModels = [EEGDecodingModel("EEGNet",API.nb_channels,API.buff_len,self.nbClasses),EEGDecodingModel("ShallowConvNet",API.nb_channels,API.buff_len,self.nbClasses)]
        self.AIClassifiers = "10221"
        self.AIInstance = AI(self.AIModels, self.AIClassifiers)
        print("Done")

        self.tk.protocol("WM_DELETE_WINDOW", self.on_closing)
        

    def on_closing(self):
        self.tk.destroy()
        if(self.APIInstance.board != None):
            self.APIInstance.stop()
            self.APIInstance.disconnect()

    

    def start(self):
        self.tk.mainloop()

    def getFiles():
        if(not fileExist(API.foldername)):
            mkdir(API.foldername)
        tmp = listdir(rootDir + API.foldername)
        InterfaceIA.files = []
        for i in tmp:
            if(len(i) > len(API.extension)):
                if(i[-1:-len(API.extension)-1:-1][::-1] == API.extension):
                    InterfaceIA.files.append(i[:len(i)-len(API.extension)])
            pass
        return InterfaceIA.files

    def getFilesSelected(self):
        filesSelected = []
        for i in self.fileSelector.curselection():
            filesSelected.append(self.fileSelector.get(i))
        return filesSelected

    def deleteFiles(self, deleteForever=False):
        filesSelected = self.getFilesSelected()
        print("Delete")
        print(filesSelected)

        if(not Tk.messagebox.askyesno("Delete files", "'re you really sure ?\nNothing will be left behind, and all this work will be lost forever...\nThink about that twice before clicking on \"Yes\".\nYou've been warn, all will be your fault.")):
            return

        if(deleteForever):
            for file in filesSelected:
                if(fileExist(rootDir+API.foldername+"/"+file+API.extension)):
                    fileDelete(rootDir+API.foldername+"/"+file+API.extension)
        else:
            if(not fileExist(rootDir+trashLocation)):
                mkdir(rootDir+trashLocation)

            date = timeNow("_trashed_%d_%m_%y___%H_%M_%S")
            for file in filesSelected:
                if(fileExist(rootDir+API.foldername+"/"+file+API.extension)):
                    fileRename(rootDir+API.foldername+"/"+file+API.extension, rootDir+trashLocation+"/"+file+date+API.extension)
        
        self.updateFileExplorer()
        self.previewFile(None)
        self.updateDeleteButton(False)
        self.updateTrainButton(False)
        

    def updateFileExplorer(self):
        self.fileSelector.delete(0, Tk.END)
        for i in InterfaceIA.getFiles():
            self.fileSelector.insert(Tk.END, i)
        


    def startAIOnLive(self):
        if(self.APIStarted):
            self.livepredictButton.configure(text="Start AI on live")
            self.APIStarted = False
            self.APIInstance.stop()
            print("API Stop request")
        else:
            self.livepredictButton.configure(text="Stop live AI")
            self.APIStarted = True
            self.APIInstance.start()
            print("API start request")

    def _onFileSelectorClick(self, event):
        length = len(self.fileSelector.curselection())
        if(length == 0):
            self.previewFile(None)
            self.updateDeleteButton(False)
            self.updateTrainButton(False)
        elif(length == 1):
            self.previewFile(self.fileSelector.get(self.fileSelector.curselection()[0]))
            self.updateDeleteButton(True)
            self.updateTrainButton(True)
        else:
            self.previewFile(None)
            self.datasetText.configure(text="Too much files selected for displaying individuals informations")


    def previewFile(self, fileName):
        if(fileName == None):
            self.datasetText.configure(text="Nothing to display")
        else:
            file = API.readFromFile(fileName)
            if( "metadata" in file ):
                metadata = file["metadata"]
                self.datasetText.configure(text=fileName+"\nFile full name : "+fileName+API.extension + "\nClasses : " + str(metadata["nb classes"]) + "  |  Length : " + str(metadata["length"]))
            else:
                self.datasetText.configure(text=fileName+"\nFile full name : "+fileName+API.extension + "\nNo metadata found...")
            #print(fileName)

    def updateDeleteButton(self, state):
        if(state):
            self.deleteButton.configure(state=Tk.NORMAL, bg="#FCC", fg="red")
        else:
            self.deleteButton.configure(state=Tk.DISABLED, bg="#CCC", fg="black")

    def updateTrainButton(self, state):
        if(state):
            self.trainButton.configure(state=Tk.NORMAL)
        else:
            self.trainButton.configure(state=Tk.DISABLED)


    def updateDatasetButton(self, state):
        if(state):
            self.createDatasetButton.configure(state=Tk.NORMAL)
        else:
            self.createDatasetButton.configure(state=Tk.DISABLED)

    """ ====== Plot functions. Used when ploting something ======  """

    def plotLine(self, x1, y1, x2, y2, color="black"):
        self.graph.create_line(x1, y1, x2, y2, fill=color)

    def plotDot(self, x, y, color="black", dotSize=1):
        self.graph.create_oval(x-dotSize, y-dotSize, x+dotSize, y+dotSize, fill=color)

    def plotText(self, x, y, text, color="black", anchor=Tk.CENTER):
        self.graph.create_text(x, y, text=text, fill=color, anchor=anchor)

    def plotRect(self, x1, y1, x2, y2, color="black"):
        self.graph.create_rectangle(x1, y1, x2, y2, fill=color)

    def plotAxes(self, xMin, xMax, yMin, yMax, subvaluesX=4, subvaluesY=4, xName="x", yName="y", gridOn=False):
        self.plotLine(0, sizeY/2-self.graphYOffset, sizeX/2, sizeY/2-self.graphYOffset)
        self.plotLine(self.graphXOffset, 0, self.graphXOffset, sizeY/2)

        self.plotText(self.graphXOffset+5, sizeY/2-self.graphYOffset+10, "{:0.3f}".format(xMin), color="gray", anchor=Tk.W)
        for i in range(1, subvaluesX+1):
            if(gridOn):
                self.plotLine(self.graphXOffset+i/subvaluesX*self.graphX, 0, self.graphXOffset+i/subvaluesX*self.graphX, sizeY/2, color="#DDD")
            self.plotLine(self.graphXOffset+i/subvaluesX*self.graphX, sizeY/2-self.graphYOffset+3, self.graphXOffset+i/subvaluesX*self.graphX, sizeY/2-self.graphYOffset-3)
            self.plotText(self.graphXOffset+i/subvaluesX*self.graphX, sizeY/2-self.graphYOffset+10, "{:0.3f}".format((xMax-xMin)/subvaluesX*i+xMin), color="gray")
            

        self.plotText(self.graphXOffset+5, sizeY/2-self.graphYOffset-10, "{:0.3f}".format(yMin), color="gray", anchor=Tk.W)
        for i in range(1, subvaluesY+1):
            if(gridOn):
                self.plotLine(0, sizeY/2-self.graphYOffset-i/subvaluesY*self.graphY, sizeX/2, sizeY/2-self.graphYOffset-i/subvaluesY*self.graphY, color="#DDD")
            self.plotLine(self.graphXOffset-3, sizeY/2-self.graphYOffset-i/subvaluesY*self.graphY, self.graphXOffset+3, sizeY/2-self.graphYOffset-i/subvaluesY*self.graphY)
            self.plotText(self.graphXOffset+5, sizeY/2-self.graphYOffset-i/subvaluesY*self.graphY, "{:0.3f}".format((yMax-yMin)/subvaluesY*i+yMin), color="gray", anchor=Tk.W)

    def plotClear(self):
        self.graph.delete('all')


    """ X and Y can be 1D array or 2D array, if 2D, each 1D array will be plotted. Each X and Y 1D array should be the same length. plotMode should be a tuple if using multiples 2D arrays plot modes, otherwise all plots will be lines. Axis should be a tuple like (xMin, xMax, yMin, yMax), "auto" to for automated axis, or None to disable """
    def plot(self, X, Y, plotMode=PLOT_LINE, axis="auto", stroke=2, color="black", subvaluesXaxis=5, subvaluesYaxis=5):
        if((type(X) not in (tuple, list)) or (type(Y) not in (tuple, list))):
            raise TypeError("X and Y should be tuples or lists")
            
        if(len(X) != len(Y)):
            raise ValueError("X and Y should be the same length")

        if((type(X[0]) not in (tuple, list))):  #Unique data
            deltaX, deltaY = max(X)-min(X), max(Y)-min(Y)
            minX, minY, maxX, maxY = min(X)-deltaX*0.1, min(Y)-deltaY*0.1, max(X)+deltaX*0.1, max(Y)+deltaY*0.1
            coefX, coefY = self.graphX/(maxX - minX), self.graphY/(maxY - minY)
            if(not (axis == "auto") and not (axis == None)):
                minX, minY, maxX, maxY = axis[0], axis[1], axis[2], axis[3]

            self.graphAxisXMin, self.graphAxisXMax, self.graphAxisYMin, self.graphAxisYMax = minX, maxX, minY, maxY

            if(not (axis == None)):
                self.plotAxes(minX, maxX, minY, maxY, gridOn=True, subvaluesX=subvaluesXaxis, subvaluesY=subvaluesYaxis)

                
            if(plotMode == InterfaceIA.PLOT_LINE):
                lX, lY = (X[0] - minX) * coefX + self.graphXOffset - minX, self.graphY - (Y[0] - minY) * coefY + self.graphYOffset
                for i, j in zip(X[1:], Y[1:]):
                    self.plotLine(lX, lY, (i - minX) * coefX + self.graphXOffset - minX, self.graphY - (j - minY) * coefY + self.graphYOffset, color=color)
                    lX, lY = (i - minX) * coefX + self.graphXOffset - minX, self.graphY - (j - minY) * coefY + self.graphYOffset
                    
            elif(plotMode == InterfaceIA.PLOT_DOT):
                for i, j in zip(X, Y):
                    self.plotDot((i - minX) * coefX + self.graphXOffset - minX, self.graphY - (j - minY) * coefY + self.graphYOffset, dotSize=stroke, color=color)
                    
            elif(plotMode == InterfaceIA.PLOT_BAR):
                for i, j in zip(X, Y):
                    self.plotRect((i - minX) * coefX + self.graphXOffset - minX - stroke, self.graphY + self.graphYOffset, (i - minX) * coefX + self.graphXOffset - minX + stroke, self.graphY - (j - minY) * coefY + self.graphYOffset, color=color)
                
            else:
                return
        else:   #Multiple data
            Xmin, Xmax, Ymin, Ymax = X[0][0], X[0][0], Y[0][0], Y[0][0]

            for x, y in zip(X, Y):
                Xmin, Xmax, Ymin, Ymax = min(min(x), Xmin), max(max(x), Xmax), min(min(y), Ymin), max(max(y), Ymax)

            deltaX, deltaY = Xmax-Xmin, Ymax-Ymin
            minX, minY, maxX, maxY = Xmin-deltaX*0.1, Ymin-deltaY*0.1, Xmax+deltaX*0.1, Ymax+deltaY*0.1
            coefX, coefY = self.graphX/(maxX - minX), self.graphY/(maxY - minY)

            if(not (axis == "auto") and not (axis == None)):
                minX, minY, maxX, maxY = axis[0], axis[1], axis[2], axis[3]

            self.graphAxisXMin, self.graphAxisXMax, self.graphAxisYMin, self.graphAxisYMax = minX, maxX, minY, maxY

            if(not (axis == None)):
                self.plotAxes(minX, maxX, minY, maxY, gridOn=True, subvaluesX=subvaluesXaxis, subvaluesY=subvaluesYaxis)
                
            if(type(plotMode) not in (list, tuple)):
                plotMode = [plotMode] * len(X)
            if(type(color) not in (list, tuple)):
                color = [color] * len(X)
            if(type(stroke) not in (list, tuple)):
                stroke = [stroke] * len(X) 
            
            for x, y, mode, c, s in zip(X, Y, plotMode, color, stroke):
                if(mode == InterfaceIA.PLOT_LINE):
                    lX, lY = (x[0] - minX) * coefX + self.graphXOffset - minX, self.graphY - (y[0] - minY) * coefY + self.graphYOffset
                    for i, j in zip(x[1:], y[1:]):
                        self.plotLine(lX, lY, (i - minX) * coefX + self.graphXOffset - minX, self.graphY - (j - minY) * coefY + self.graphYOffset, color=c)
                        lX, lY = (i - minX) * coefX + self.graphXOffset - minX, self.graphY - (j - minY) * coefY + self.graphYOffset
                    
                elif(mode == InterfaceIA.PLOT_DOT):
                    for i, j in zip(x, y):
                        self.plotDot((i - minX) * coefX + self.graphXOffset - minX, self.graphY - (j - minY) * coefY + self.graphYOffset, dotSize=s, color=c)
                    
                elif(mode == InterfaceIA.PLOT_BAR):
                    for i, j in zip(x, y):
                        self.plotRect((i - minX) * coefX + self.graphXOffset - minX - s, self.graphY + self.graphYOffset, (i - minX) * coefX + self.graphXOffset - minX + s, self.graphY - (j - minY) * coefY + self.graphYOffset, color=c)


    def graphHovered(self, event):
        if(event.x > sizeX/4 and event.y > sizeY/4):
            self.graphHoverlay.place(relx=event.x/sizeX*2 - 0.02, rely=event.y/sizeY*2 - 0.02, anchor=Tk.SE)
        elif(event.x > sizeX/4 and event.y <= sizeY/4):
            self.graphHoverlay.place(relx=event.x/sizeX*2 - 0.02, rely=event.y/sizeY*2 + 0.02, anchor=Tk.NE)
        elif(event.x <= sizeX/4 and event.y > sizeY/4):
            self.graphHoverlay.place(relx=event.x/sizeX*2 + 0.02, rely=event.y/sizeY*2 - 0.02, anchor=Tk.SW)
        else:
            self.graphHoverlay.place(relx=event.x/sizeX*2 + 0.02, rely=event.y/sizeY*2 + 0.02, anchor=Tk.NW)
        
        self.graphHoverlay.configure(text="X : {:.3f}\nY : {:.3f}".format(((event.x-self.graphXOffset)*(self.graphAxisXMax-self.graphAxisXMin)/self.graphX)+self.graphAxisXMin, ((event.y-self.graphYOffset)*(self.graphAxisYMin-self.graphAxisYMax)/self.graphY)+self.graphAxisYMax))

    def graphNotHovered(self, event):
        self.graphHoverlay.place(relx=-100, rely=-100)



                

    """ ====== Settings and QoL things ====== """

    def openGraphSettings(self, event):
        print("Open graph settings")
        #print(event)
    

    def openBCIMenu(self):
        #Init menu
        if(not self.openBCIWin == None):
            try:
                self.openBCIWin.destroy()
            except Exception:
                self.openBCIWin = None
            self.openBCIWin = None
        
        self.openBCIWin = Tk.Tk()
        self.openBCIWin.geometry("{}x{}+{}+{}".format(sizeX, sizeY, self.tk.winfo_x(), self.tk.winfo_y()))
        self.openBCIWin.resizable(0,0)
        self.openBCIWin.title("OpenBCI settings menu")

        # Frames
        connectFrame = Tk.Frame(self.openBCIWin, padx=10, pady=10, width=sizeX/5, height=sizeY)
        connectFrame.place(relx=0, rely=0, anchor=Tk.NW)

        keyboardOptionFrame = Tk.Frame(self.openBCIWin, padx=10, pady=10, width=2*sizeX/5, height=sizeY)
        keyboardOptionFrame.place(relx=1/5, rely=0, relwidth=2/5, relheight=1)

        


        # connectFrame widgets
        self.comPortsListbox = Tk.Listbox(connectFrame)
        self.comPortsListbox.place(relx=0.5, rely=0.5, anchor=Tk.CENTER)
        self.comPortsListbox.bind('<<ListboxSelect>>',self._onPortClick)

        refreshButton = Tk.Button(connectFrame, text="Refresh ports", command=self.updateCOMPorts)
        refreshButton.place(relx=0, rely=1, anchor=Tk.SW)

        self.connectButton = Tk.Button(connectFrame, text="Connect", command=self.connectToPort, bg="#AFA", fg="green", state=Tk.DISABLED)
        self.connectButton.place(relx=1, rely=1, anchor=Tk.SE)
        if(self.APIConnected == None):
            self.connectButton.configure(text="Connect", bg="#AFA", fg="green")
            self.comPortsListbox.configure(state=Tk.NORMAL)
            self.livepredictButton.configure(state=Tk.DISABLED)
        else:
            self.connectButton.configure(text="Disconnect", bg="#FCC", fg="red", state=Tk.NORMAL)
            self.comPortsListbox.configure(state=Tk.DISABLED)
            self.livepredictButton.configure(state=Tk.NORMAL)
            
        self.updateCOMPorts()


        #AI Feedback options
        j = 1
        Tk.Label(keyboardOptionFrame, text="AI feedback keyboard assignment").grid(row=0, column=0, columnspan=2)
        for i in self.returnDict:
            self.selectvarKeyboard[i] = Tk.StringVar(keyboardOptionFrame)
            self.selectvarKeyboard[i].set(self.returnDict[i])
            self.optionmenuKeyboard[i] = Tk.OptionMenu(keyboardOptionFrame, self.selectvarKeyboard[i], *self.availableKeys, command=self.updateKeybind)
            self.optionmenuKeyboard[i].config(width=10)
            Tk.Label(keyboardOptionFrame, text=self.DATASET_NAME[i]).grid(row=j, column=0)
            self.optionmenuKeyboard[i].grid(row=j, column=1)
            
            j += 1

        #Dataset options
        Ttk.Separator(keyboardOptionFrame, orient=Tk.HORIZONTAL).grid(row=j, column=0, columnspan=2, sticky=Tk.EW)
        Tk.Label(keyboardOptionFrame, text="Dataset settings").grid(row=j+1, column=0, columnspan=2)
        Tk.Label(keyboardOptionFrame, text="Number of inputs :").grid(row=j+2, column=0)

        value = self.datasetActions[list(self.datasetActions)[0]][0]
        
        self.selectvarDatasetNumber = Tk.StringVar(keyboardOptionFrame, value=str(value))
        
        self.entryDatasetNumber = Tk.Entry(keyboardOptionFrame, textvariable=self.selectvarDatasetNumber, validate='all', validatecommand=(keyboardOptionFrame.register(lambda P: (str.isdigit(P) or P == "")), "%P"))
        self.entryDatasetNumber.grid(row=j+2, column=1)
        


    def updateKeybind(self, e):
        for i in self.returnDict:
            self.returnDict[i] = self.selectvarKeyboard[i].get()
            if(self.returnDict[i] == "None"):
                self.returnDict[i] = None

    def updateCOMPorts(self):
        if(not self.APIConnected == None):
            return
        
        self.connectButton.configure(state=Tk.DISABLED)
        self.comPortsListbox.delete(0, Tk.END)
        for port in API.getSerialPorts():
            self.comPortsListbox.insert(Tk.END, port[0])

    def _onPortClick(self, event):
        self.connectButton.configure(state=Tk.NORMAL)

    def connectToPort(self):
        if(len(self.comPortsListbox.curselection()) == 1 or not (self.APIConnected == None) ):
            if(self.APIConnected == None):
                self.APIConnected = self.comPortsListbox.get(self.comPortsListbox.curselection()[0])
                self.connectButton.configure(text="Disconnect", bg="#FCC", fg="red")
                self.comPortsListbox.configure(state=Tk.DISABLED)
                self.livepredictButton.configure(state=Tk.NORMAL)
                self.updateDatasetButton(True)
                print("Connect to port " + self.APIConnected)
                self.APIInstance.connect(self.APIConnected)
            else:
                print("Disconnect from " + self.APIConnected)
                self.connectButton.configure(text="Connect", bg="#AFA", fg="green")
                self.comPortsListbox.configure(state=Tk.NORMAL)
                self.livepredictButton.configure(state=Tk.DISABLED)
                self.updateDatasetButton(False)
                self.APIInstance.disconnect()
                self.APIConnected = None
                self.updateCOMPorts()
    

    
            
    """ ====== API to AI bridge ====== """

    def fromAPIToAI(self, data):
        epo = API.convertDataToEpoch(data)
        predict = self.AIInstance.predict(epo)[0]
        print("Prediction : ", predict)
        if(predict in self.returnDict.keys()):
            if(self.returnDict[predict] != None):
                print("Press and release", self.returnDict[predict])
                pressKey(self.returnDict[predict])
        
    global debugEpo
    
    def startAITrain(self):
        global debugEpo
        filesSelected = self.getFilesSelected()

        for file in filesSelected:
            data = API.readFromFile(file)
            print("Training : \"" + file + "\"")
            for i in data:
                if(i != "metadata"):
                    print("Sending \"" + self.DATASET_NAME[i] + "\" to AI")
                    toTrain = API.convertDataToEpoch(data[i])
                    
                    print(np.shape(toTrain.get_data()))
                    print(toTrain.get_data())
                    print(np.array([i]*np.shape(toTrain.get_data())[0]))
                    debugEpo = toTrain
                    self.AIInstance.train(toTrain, np.array([i]*np.shape(toTrain.get_data())[0]), False, self.nbEpochTrain)
                
                
        











    """ Dataset creation """
    def createNewDataset(self):
        #Init menu
        if(not self.openBCIDataset == None):
            try:
                self.openBCIDataset.destroy()
            except Exception:
                self.openBCIDataset = None
            self.openBCIDataset = None

        numberOfLoop = int(self.selectvarDatasetNumber.get())
        for i in self.datasetActions:
            self.datasetActions[i][0] = numberOfLoop
        
        self.openBCIDataset = Tk.Tk()
        self.openBCIDataset.title("OpenBCI Dataset creation")
        self.openBCIDataset.attributes('-fullscreen', True)
        self.openBCIDataset.focus_force()
        self.openBCIDataset.bind('<Escape>', lambda e: self._datasetEnd(abort=True))

        self.datasetCanvas = Tk.Canvas(self.openBCIDataset, width=self.openBCIDataset.winfo_screenwidth(), height=self.openBCIDataset.winfo_screenheight())
        self.datasetCanvas.place(relx=0, rely=0, relwidth=1, relheight=1)


        self.datasetCanvas.configure(bg='black')
        self.openBCIDataset.bind('<space>', lambda e: self._datasetInitUI())

        

        #Roll the intro
        self._datasetNextStep(0);
        #self._datasetEnd()


    def _datasetNextStep(self, index):
        
        if(index >= len(self.datasetIntroText)):
            self._datasetInitUI()
            return
        else:
            self.tmp = self.datasetCanvas.after(self.datasetIntroText[index][1], self._datasetNextStep, index+1)
            
        self.datasetCanvas.delete('all')
        self.datasetCanvas.create_text(self.screenX/2, self.screenY/2, text=self.datasetIntroText[index][0], fill="white", font=('Helvetica 15 bold'))
        self.datasetCanvas.create_text(self.screenX/2, self.screenY*9/10, text="Appuyer sur [space] pour passer l'intro", fill="white", font=('Helvetica 15 bold'))
        self.datasetCanvas.create_text(self.screenX/2, self.screenY*9.5/10, text="A tout moment, appuyer sur [Esc] pour quitter sans enregistrer", fill="white", font=('Helvetica 15 bold'))
        
        

        

    def _datasetInitUI(self):
        self.datasetCanvas.after_cancel(self.tmp)
        self._datasetBlack()

        # Shuffle the dataset
        tmpDataset = []
        self.dataset = []
        length = 0
        for i in self.datasetActions:
            length += self.datasetActions[i][0]
            tmpDataset += [i] * self.datasetActions[i][0]

        print("length", length)
        print(tmpDataset)
        tmpDataset = sample(tmpDataset, len(tmpDataset))
        print(tmpDataset)
        

        self.datasetTempo = 0
        self.datasetReadWindows = []
        for i in tmpDataset:
            self.dataset.append([self.DATASET_CROSS_1, self.datasetTempo + self.DATASET_CROSS_1_DURATION])
            self.datasetTempo += self.DATASET_CROSS_1_DURATION
            
            self.dataset.append([i, self.datasetTempo + self.datasetActions[i][1]])
            self.datasetTempo += self.datasetActions[i][1]


            padding = (self.DATASET_CROSS_2_DURATION%1)/2
            nbAcq = floor(self.DATASET_CROSS_2_DURATION)
            for j in range(nbAcq):
                self.datasetReadWindows.append([self.datasetTempo+padding+j, self.datasetTempo+padding+1+j, i])
            
            
            
            self.dataset.append([self.DATASET_CROSS_2, self.datasetTempo + self.DATASET_CROSS_2_DURATION])
            self.datasetTempo += self.DATASET_CROSS_2_DURATION
            
            self.dataset.append([self.DATASET_BLACK, self.datasetTempo + self.DATASET_BLACK_DURATION])
            self.datasetTempo += self.DATASET_BLACK_DURATION
            

        print(self.dataset)

        
        self.datasetCanvas.create_text(self.screenX/2, self.screenY/2, text="Durée de l'entraînement : {} secondes".format(self.datasetTempo), fill="white", font=('Helvetica 15 bold'))
        self.datasetCanvas.create_text(self.screenX/2, self.screenY*9/10, text="Appuyer sur [Enter] pour commencer", fill="white", font=('Helvetica 15 bold'))
        self.openBCIDataset.bind('<Return>', lambda e: self._datasetStart())
        self.openBCIDataset.unbind("<space>")
        
    def _datasetStart(self):
        self.openBCIDataset.unbind("<Return>")
        self.threadAcquire = threading.Thread(target=self._datasetAcquireFeedback)
        self.threadAcquire.start()

        self.datasetCanvas.after(10, self._datasetRun, 0, time())
         
        
    def _datasetRun(self, index, t_start):
            
        if(time() - t_start >= self.dataset[index-1][1] or index == 0):
            print("[", int((time()-t_start)*10)/10, "s] Action : ", self.DATASET_NAME[self.dataset[index][0]], " | Durée : ", self.dataset[0][1] if(index == 0) else self.dataset[index][1] - self.dataset[index-1][1], "s")
            if(self.dataset[index][0] == self.DATASET_LEFT):
                self._datasetLeft()
            elif(self.dataset[index][0] == self.DATASET_RIGHT):
                self._datasetRight()
            elif(self.dataset[index][0] == self.DATASET_NONE):
                self._datasetCross()
            elif(self.dataset[index][0] == self.DATASET_BLACK):
                self._datasetBlack()
            elif(self.dataset[index][0] == self.DATASET_CROSS_1 or self.dataset[index][0] == self.DATASET_CROSS_2):
                self._datasetCross()
            index += 1
            
        

        if(index < len(self.dataset)):
            self.datasetCanvas.after(10, self._datasetRun, index, t_start)
        else:
            self._datasetBlack()
            self.datasetCanvas.create_text(self.screenX/2, self.screenY*9/10, text="Traitement des données... Veuillez patienter...", fill="white", font=('Helvetica 15 bold'))
            self.datasetCanvas.after(100, self._datasetPostprocessing)
            
        

        

    def _datasetRight(self):
        self._datasetCross()
        self.datasetCanvas.create_line(self.screenX/5, self.screenY/2, self.screenX*1/3, self.screenY*2/5, fill="white", width=5)
        self.datasetCanvas.create_line(self.screenX/5, self.screenY/2, self.screenX*1/3, self.screenY*3/5, fill="white", width=5)
        
    

    def _datasetLeft(self):
        self._datasetCross()
        self.datasetCanvas.create_line(self.screenX*4/5, self.screenY/2, self.screenX*2/3, self.screenY*2/5, fill="white", width=5)
        self.datasetCanvas.create_line(self.screenX*4/5, self.screenY/2, self.screenX*2/3, self.screenY*3/5, fill="white", width=5)        
        


    def _datasetCross(self):
        self._datasetBlack()
        self.datasetCanvas.create_line(self.screenX/5, self.screenY/2, self.screenX*4/5, self.screenY/2, fill="white", width=5)
        self.datasetCanvas.create_line(self.screenX/2, self.screenY/5, self.screenX/2, self.screenY*4/5, fill="white", width=5)
        

    def _datasetBlack(self):
        self.datasetCanvas.delete('all')

    def _datasetAcquireFeedback(self):
        self.datasetData = self.APIInstance.acquire(ceil(self.datasetTempo))

    def _datasetPostprocessing(self):
        if(self.threadAcquire != None):
            self.threadAcquire.join()
        
        tmpData = {}
        for i in self.datasetActions:
            tmpData[i] = []
            for j in range(16):
                tmpData[i].append([])
        
        print(tmpData)
        print(self.datasetReadWindows)

        for i in self.datasetReadWindows:
            for j in range(16):
                for k in self.datasetData[j][floor(API.Freq_sampling * i[0]):floor(API.Freq_sampling * i[1])]:
                    tmpData[i[2]][j].append(k)

        self.datasetData = tmpData
        self._datasetEnd()

    def _datasetEnd(self, abort=False):
        self.openBCIDataset.unbind("<Escape>")
        if(abort):
            self.datasetCanvas.after_cancel(self.tmp)
            self.APIInstance.stopAcquire()
            self.openBCIDataset.destroy()
            print("Abort dataset protocol");
            return
        print("Dataset protocol end");

        self.datasetCanvas.destroy()
        self.openBCIDataset.attributes('-fullscreen', False)
        self.openBCIDataset.geometry("{}x{}+{}+{}".format(sizeX//2, sizeY//2, self.tk.winfo_x()+sizeX//4, self.tk.winfo_y()+sizeY//4))

        Tk.Label(self.openBCIDataset, text="First name").grid(row=0, column=0)
        self.entry1stName = Tk.Entry(self.openBCIDataset)
        self.entry1stName.grid(row=0, column=1)

        Tk.Label(self.openBCIDataset, text="Name").grid(row=1, column=0)
        self.entryName = Tk.Entry(self.openBCIDataset)
        self.entryName.grid(row=1, column=1)

        Tk.Label(self.openBCIDataset, text="Email").grid(row=2, column=0)
        self.entryEmail = Tk.Entry(self.openBCIDataset)
        self.entryEmail.grid(row=2, column=1)

        Tk.Button(self.openBCIDataset, text="Done", command=self._datasetFinalize).grid(row=3, column=0, columnspan=2)



    def _datasetFinalize(self):
        name =  self.entryName.get()
        firstName = self.entry1stName.get()
        email = self.entryEmail.get()
        if(name == "" or firstName == "" or email == ""):
            return
        print("name =", name, "1st name =", firstName, "Email =", email)

        metadata = {"email": email, "nb classes": len(list(self.datasetActions)), "length": self.datasetActions[list(self.datasetActions)[0]][0]}

        self.datasetData["metadata"] = metadata

        print(self.datasetData["metadata"])
        API.exportToFile(self.datasetData, name + "_" + firstName)
        self.openBCIDataset.destroy()
        self.updateFileExplorer()

        


#Debug function
if __name__ == "__main__":
    global interface
    interface = InterfaceIA()
    interface.start()














