# DATASET
Le dataset BCI Competition 2008 2a doit être téléchargé sur le lien suivant : https://www.bbci.de/competition/iv/ 
Pour pouvoir exécuter les programmes d'exemples fournis dans ce dossier, il faudra placer le dataset dans un dossier nommé /dataset_2a et les étiquettes correspondantes dans un dossier nommé /labels.
# EXAMPLES
Le dossier examples contient le code que nous présentons à des fins d'exemple (par exemple pour apprendre à utiliser les différentes librairies utilisées dans le cadre du projet) ou pour tracer les graphiques présentés dans nos rapports de projet. Pour les faire fonctionner correctement, il faudra bien veiller à mettre les dossiers dataset et labels dans le même dossier que ces programmes.

# ARCHIVES
Le dossier archives contient les fonctions et les programmes qui ont été utilisées précédemment dans la réalisation du projet mais qui ne sont plus utilisées dorénavant.
# STRUCTURE DES CLASSES DÉVELOPPÉES
Architecture des classes relatives à l'Intelligence Artificielle :

 ![Screenshot](diagramme_classe_ia_projet_4a.png) 

Architecture des classes relatives au chiffrement/déchiffrement des fichiers et à la protection des donnés personnelles :

 ![Screenshot](diagramme_classes_cryptage_decryptage_dataset_projet_4a2.jpg) 

# DESCRIPTION DES FICHIERS ESSENTIELS 

# Fichier crypt_utils.py
Ce fichier comprend deux classes principales : FileEncrypter et FileDecrypter. Ces deux classes vont permettre de crypter et décrypter les fichiers EEG (tout en appliquant un hash au nom de fichier pour pseudonymiser les données). Elles permettent ainsi d'appliquer notre politique de protection des données personnelles et donc conformer notre projet au RGPD.

# Programme crypt_example
Ce programme montre comment utiliser les deux classes FileEncrypter et FileDecrypter pour crypter et décrypter les datasets. Pour l'utiliser, il faudra veiller a avoir à la racine du projet un fichier à crypter dont le nom est défini avec la variable filename.

# Fichier EEGDecodingModel.py
Ce fichier contient la classe EEGDecodingModel permettant de classifier un signal EEG en utilisant un des réseaux de neurones développé par l'ARL (Army Research Laboratory).

# Programme experiment_models.py
Ce programme montre comment utiliser la classe EEGDecodingModel pour classifier les signaux EEG issus du dataset BCI Competition 2008 2a.

# Fichier ComposedClassifier.py
Ce fichier contient la classe ComposedClassifier qui implémente un classifieur d'ensemble basé sur les 3 réseaux ARL (EEGNet, DeepConvNet et ShallowConvNet) afin de classifier des signaux EEG. Ce classifieur exploite la méthode de fusion de données du vote à la majorité.

# Fichier experiment_composed_classifier.py
Ce programme a pour vocation de montrer comment utiliser la classe ComposedClassifier sur le dataset BCI Competition
2008 2a pour classifier des signaux EEG de mouvements imaginés. Ce programme utilise des réseaux convolutifs ARL
(classe EEGDecodingModel) et un classifieur SVR couplé à un filtrage FBCSP (classe EEGDecodingModelFBCSP) pour classifier
les signaux EEG pour l'ensemble des sujets du dataset.

# Fichier EEGDecodingModelFBCSP.py
Cette classe permet de classifier des signaux EEG sur la base d'un classifieur SVR couplé à un traitement de signal basé sur la technologie FBCSP (Filter Bank Common Spatial Patterns).

# Programme estimate_prediction_time.py
Ce court programme a pour vocation de calculer l'intervalle de confiance à 95% du temps de prédiction pour chaque
classifieur définit précédemment de manière indépendante ainsi que pour le classifieur d'ensemble.

# Fichier PersonalDataManager.py
Ce fichier contient la classe PersonalDataManager, permettant d'accéder aux données EEG d'une personne sur sa demande
afin de lui fournir au format csv (droit d'accès) ou encore de supprimer ses données (droit à l'effacement). C'est
cette classe qui permet d'assurer la conformité au RGPD du projet en permettant l'exercice des différents droits
prévus par ce-dernier.

# Fichier EEGDataEnhancer.py
Ce fichier contient la classe EEGDataEnhancer qui a pour objectif de permettre d'augmenter le nombre de données d'un dataset de signaux EEG par extraction de bruit et fusion avec des signaux aléatoires.

# Programme experiment_data_augmentation.py
Ce programme montre comment utiliser la classe EEGDataEnhancer afin d'augmenter le nombre de données d'un extrait du dataset BCI Competition 2008 2a.

